SystemOrganization addCategory: #Geometry!
SystemOrganization addCategory: 'Geometry-Test'!

!Point methodsFor: '*Geometry' stamp: 'NataliaTymchuk 2/19/2015 15:27'!
=~ aPoint
	^ (self dist: aPoint) =~ 0
! !

!Point methodsFor: '*Geometry' stamp: 'NataliaTymchuk 7/7/2014 12:39'!
ray: aPoint 
	^ GRay origin: self direction: aPoint ! !

!Point methodsFor: '*Geometry' stamp: 'NataliaTymchuk 7/6/2014 23:34'!
segment: aPoint 
	^ GSegment with: self with: aPoint ! !

!Point methodsFor: '*Geometry' stamp: 'NataliaTymchuk 7/6/2014 23:50'!
signFuz
	^ (x signFuz @ y signFuz)! !

!Point methodsFor: '*Geometry' stamp: 'NataliaTymchuk 2/19/2015 15:30'!
~=~ aPoint
	^ (self =~ aPoint) not! !

!Number class methodsFor: '*geometry' stamp: 'NataliaTymchuk 2/19/2015 15:22'!
epsilon
	^ 0.00001! !

!Number methodsFor: '*Geometry' stamp: 'NataliaTymchuk 2/19/2015 15:23'!
=~ aNumber 
	^((self - aNumber) abs) < Number epsilon.! !

!Number methodsFor: '*Geometry' stamp: 'NataliaTymchuk 7/6/2014 23:50'!
signFuz
	"Answer 1 if the receiver is greater than 0, -1 if less than 0, else 0."

	self >~ 0 ifTrue: [ ^  1 ].
	self <~ 0 ifTrue: [ ^ -1 ].
	^ 0! !

!Number methodsFor: '*Geometry' stamp: 'NataliaTymchuk 2/19/2015 15:32'!
~=~ aNumber
   ^ (self =~ aNumber) not! !

TestCase subclass: #GCircleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry-Test'!

!GCircleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/28/2014 11:42'!
testBoundaryContains
	self
		assert: ((GCircle  center: 2 @ 2 radius: 3) boundaryContains: 2 @ 2)
		equals: false! !

!GCircleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/28/2014 11:42'!
testBoundaryContains1
	self
		assert: ((GCircle  center: 2 @ 2 radius: 3) boundaryContains: 5 @ 2)
		equals: true! !

!GCircleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/20/2014 18:44'!
testBoundaryContainsThis
	self
		assert: ((GCircle  center: 2 @ 2 radius: 3) boundaryContainsThis: { 2 @ 2 . 5 @ 2 })
		equals: true! !

!GCircleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/20/2014 18:40'!
testBoundaryContainsWhich
	self
		assert: ((GCircle  center: 2 @ 2 radius: 3) boundaryContainsWhichOf: { 2 @ 2 . 5 @ 2 })
		equals: {5 @ 2}! !

!GCircleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/28/2014 11:42'!
testContains
	self
		assert: ((GCircle  center: 2 @ 2 radius: 3) contains: 2 @ 2)
		equals: true! !

!GCircleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/28/2014 11:42'!
testContains1
	self
		assert: ((GCircle  center: 2 @ 2 radius: 3) contains: 6 @ 2)
		equals: false! !

!GCircleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 3/2/2015 15:25'!
testEquel
	self
		assert: (GCircle  center: 1 @ 1 radius: 3) = (GCircle  center: 1 @ 1 radius: 3)
		equals: true! !

!GCircleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 3/2/2015 15:26'!
testEquel1
	self
		assert: (GCircle  center: 1 @ 1 radius: 3) = (GCircle  center: 1.002 @ 1.009 radius: 3)
		equals: false
	! !

!GCircleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 3/2/2015 15:26'!
testEquel2
	self
		assert: (GCircle  center: 1 @ 1 radius: 3) = (GCircle  center: 1 @ 1 radius: 2.999999999)
		equals: true
	! !

!GCircleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 3/2/2015 15:26'!
testEquel3
	self
		assert: (GCircle  center: 1 @ 1 radius: 3) = (GCircle  center: 1.00000001 @ 0.9999991 radius: 2.999999999)
		equals: true
	! !

!GCircleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 3/2/2015 15:27'!
testEquel4
	self
		assert: (GCircle  center: 1 @ 1 radius: 3) = (GCircle  center: 1 @ 1 radius: 34)
		equals: false
	! !

!GCircleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 3/2/2015 15:27'!
testEquel5
	self
		assert: (GCircle  center: 1.4 @ 1 radius: 3) = (GCircle  center: 1 @ 1 radius: 34)
		equals: false
	! !

!GCircleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/20/2014 18:03'!
testPolygonOn
	self
		assert: (((GCircle  center: 1 @ 1 radius: 3) polygonOn: { -20 @ 10 ". 10 @ 40" . 40 @ 10 . 10 @ -20 }) at:1 )v1
		equals: -20 @ 10! !

!GCircleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 1/30/2015 12:38'!
testupperPoint
	self
		assert: (GCircle  center: 1 @ 1 radius: 3) upperPoint
		equals: 1 @ 4! !

TestCase subclass: #GLineTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry-Test'!

!GLineTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchyk 1/21/2015 13:40'!
testCutWith
	self
		assert: ((GLine a: -20  b: 30  c: -500 ) cutWith: (Rectangle origin: -15 @ 0 corner: 15 @ 15 )) v1
		equals: (-15@(20/3)).
	self
		assert: ((GLine a: -20  b: 30  c: -500 ) cutWith: (Rectangle origin: -15 @ 0 corner: 15 @ 15 )) v2
		equals: ((-5/2)@15).	
	self
		assert: ((GLine a: -30  b: 50  c: -900 ) cutWith: (Rectangle origin: -15 @ 0 corner: 15 @ 15 )) v1 
		equals: (-15 @ 9) .	
	self
		assert: ((GLine a: -30  b: 50  c: -900 ) cutWith: (Rectangle origin: -15 @ 0 corner: 15 @ 15 )) v2 
		equals: (-5 @ 15).
	self
		assert: ((GLine a: 0  b: 1  c: -25 ) cutWith: (Rectangle origin: -15 @ 0 corner: 15 @ 15 ))
		equals: nil.	! !

!GLineTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 2/19/2015 13:38'!
testEquel
self
	assert: ((GLine a:1 b:1 c: -13)= (GLine a:6 b:6 c: -78))
	equals: true.
self
	assert: ((GLine a:0 b:1 c: -13)= (GLine a:0 b:6 c: -78))
	equals: true.
self
	assert: ((GLine a:1 b:1 c: -13)= (GLine a:1 b:6 c: -78))
	equals: false.
self
	assert: ((GLine a:1 b:1 c: -13)= (GLine a:6 b:6 c: -7))
	equals: false.
self
	assert: ((GLine a:1 b:0 c: -13)= (GLine a:6 b:0 c: -78))
	equals: true.
self
	assert: ((GLine a:0 b:1 c: 0)= (GLine a:0 b:6 c: 0))
	equals: true.
self
	assert: ((GLine a:1 b:0 c: 0)= (GLine a:1 b:0 c: 0))
	equals: true.
! !

!GLineTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 2/18/2015 09:42'!
testEquel1
self
	assert: ((GLine a:1 b:1 c: -13)= (GLine a:6 b:6 c: 0))
	equals: false.
self
	assert: ((GLine a:0 b:1 c: -13)= (GLine a:0 b:6 c: -78))
	equals: true.

	! !

!GLineTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 2/19/2015 13:51'!
testEquel2
self
	assert: ( ( GLine a: -48.989794855663575 b: 48.98979485566357 c: 4.547473508864641e-13 ) = ( GLine a:
	-138.58803762173304 b: 138.58803762173304 c: 1.8189894035458565e-12 ) )
	equals: true.
! !

!GLineTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 2/19/2015 13:50'!
testEquel3
self
	assert: ( ( 
	( GSegment with: ( -24.494897427831784 @ -24.494897427831795 ) with: ( 24.494897427831784 @ 24.49489742783178 ) ) asLine
	= (
	( GSegment with: ( -99.30232333601874 @ -99.30232333601876 ) with: ( 39.285714285714285 @ 39.28571428571428 ) ) asLine )
	) )
	equals: true.
! !

!GLineTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 2/19/2015 13:50'!
testEquel4
self
	assert: ( ( 
	( GSegment with: ( -24.494897427831784 @ -24.494897427831795 ) with: ( 24.494897427831784 @ 24.49489742783178 ) ) asLine
	= (
	( GSegment with: ( 24.494897427831784 @ 24.49489742783178 ) with: ( -24.494897427831784 @ -24.494897427831795 ) ) asLine )
	) )
	equals: true.
! !

!GLineTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/11/2014 17:24'!
testIntersect
self
	assert: ((GLine a: 2 b: -3 c: 0.5) intersect: (GLine a: 1 b: 1 c: -2))
	equals: 1.1 @ 0.9! !

!GLineTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/11/2014 17:37'!
testIntersect1
self
	assert: ((GLine a: 2 b: -3 c: 0.5) intersect: (GLine a: -2 b: -2 c: 4))
	equals: 1.1 @ 0.9! !

!GLineTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/12/2014 20:22'!
testParallelTo
self
	assert: ((GLine a: 0 b: -3 c: 0.5) parallelTo: (GLine a: -2 b: 0 c: 4))
	equals: false.
self
	assert: ((GLine a: 0 b: -3 c: 0.5) parallelTo: (GLine a: -2 b: 1 c: 4))
	equals: false.
self
	assert: ((GLine a: 1 b: 2 c: 0.5) parallelTo: (GLine a: 2 b: 4 c: 4))
	equals: true.
self
	assert: ((GLine a: 0 b: 2 c: 0.5) parallelTo: (GLine a: 0 b: 2 c: 0.5))
	equals: true.! !

!GLineTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchyk 1/21/2015 13:48'!
testThroughAndHasPoint
self
	assert: ((GLine through: 1@1 and: 3@3)through: 1@1 and: 3@3 hasPoint: 2@2 )
	equals: true.
self
	assert: ((GLine through: 1@1 and: 2@2)through: 1@1 and: 2@2 hasPoint: 3@3 )
	equals: true.
self
	assert: ((GLine through: 1@1 and: 2@2)through: 1@1 and: 2@2 hasPoint: 2@1 )
	equals: false.! !

TestCase subclass: #GPolygonTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry-Test'!

!GPolygonTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/27/2014 21:10'!
testConvexHullOn
self
	assert: ((GPolygon convexHullOn:{ 0 @ -20 . 0 @ 10 . 30 @ -30 . 40 @ 0 . -10 @ 0 . 40 @ -20 } ) vertices )
	equals:{ -10 @ 0 . 0 @ -20 . 30 @ -30 . 40 @ -20 . 40 @ 0 . 0 @ 10 } asOrderedCollection! !

!GPolygonTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/27/2014 21:11'!
testConvexHullOn1
self
	assert: ((GPolygon convexHullOn:{ 0 @ -20 . 0 @ 10 . 30 @ -30 . 0 @ 0 . 40 @ 0 . -10 @ 0 . 40 @ -20 } ) vertices )
	equals:{ -10 @ 0 . 0 @ -20 . 30 @ -30 . 40 @ -20 . 40 @ 0 . 0 @ 10 } asOrderedCollection! !

TestCase subclass: #GRayTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry-Test'!

!GRayTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchyk 1/21/2015 13:40'!
testCutWith
	self
		assert: ((GRay origin: -10 @ 10 direction: 20 @ 30) cutWith: (Rectangle origin: -15 @ 0 corner: 15 @ 15 )) v1
		equals: (-5/2)@15.
	self
		assert: ((GRay origin: -10 @ 10 direction: 20 @ 30) cutWith: (Rectangle origin: -15 @ 0 corner: 15 @ 15 )) v2
		equals: -10 @ 10.	
	self
		assert: ((GRay origin: -30 @ 0 direction: 20 @ 30) cutWith: (Rectangle origin: -15 @ 0 corner: 15 @ 15 )) v1 
		equals: (-15 @ 9) .	
	self
		assert: ((GRay origin: -30 @ 0 direction: 20 @ 30) cutWith: (Rectangle origin: -15 @ 0 corner: 15 @ 15 )) v2 
		equals: (-5 @ 15).
	self
		assert: ((GRay origin: -30 @ 30 direction: 20 @ 30) cutWith: (Rectangle origin: -15 @ 0 corner: 15 @ 15 ))
		equals: nil.	! !

!GRayTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/7/2014 11:29'!
testFlipped
	self
		assert: ((GRay origin: 100 @ 100 direction: 80 @ 110) flipped )direction
		equals: 120 @ 90.
	self
		assert: ((GRay origin: 100 @ 100 direction:  120 @ 90) flipped )direction
		equals: 80 @ 110! !

!GRayTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/7/2014 11:29'!
testHasPoint
	self
		assert: ((GRay origin: 100 @ 100 direction: 80 @ 110) hasPoint: 120 @ 90)
		equals: false.
	self
		assert: ((GRay origin: 100 @ 100 direction: 120 @ 90) hasPoint: 120 @ 90)
		equals: true.
	self
		assert: ((GRay origin: 100 @ 100 direction: 120 @ 90) hasPoint: 100 @ 100)
		equals: true.
	self
		assert: ((GRay origin: 100 @ 100 direction: 110 @ 110) hasPoint: 150 @ 150)
		equals: true.	! !

TestCase subclass: #GRectangleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry-Test'!

!GRectangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/30/2014 22:07'!
testHasOnBoundary
	self assert:((Rectangle origin:  1 @ 3 corner: 3 @ 0) hasOnBoundary: 1 @ 3)
   		equals: true.
	self assert:((Rectangle origin:  1 @ 3 corner: 3 @ 0) hasOnBoundary: 2 @ 3)
   		equals: true.
	self assert:((Rectangle origin:  1 @ 3 corner: 3 @ 0) hasOnBoundary: 0 @ 0)
   		equals: false.! !

!GRectangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/23/2014 17:00'!
testHasOnOneSideAnd

self 
	assert:((Rectangle origin: -22 @ -42 corner: 62 @ 42) hasOnOneSide: -9 @ 42 and: 30 @ 42)
	equals: true. 
self 
	assert:((Rectangle origin: -22 @ -42 corner: 62 @ 42) hasOnOneSide: -22 @ 30 and: -22 @ -10)
	equals: true. 
self 
	assert:((Rectangle origin: -22 @ -42 corner: 62 @ 42) hasOnOneSide: -9 @ 42 and: -22 @ -10)
	equals: false. ! !

!GRectangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/23/2014 11:32'!
testHasPoint
	self assert:((Rectangle origin:  1 @ 3 corner: 3 @ 0) hasPoint: 1 @ 3)
   		equals: true.
	self assert:((Rectangle origin:  1 @ 3 corner: 3 @ 0) hasPoint: 2 @ 1)
   		equals: true.
	self assert:((Rectangle origin:  1 @ 3 corner: 3 @ 0) hasPoint: 0 @ 0)
   		equals: false.! !

!GRectangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 2/17/2015 00:32'!
testIntersectionPointWithRay
 	self assert:((Rectangle origin:  1 @ 3 corner: 3 @ 0) intersectionPointWithRay: ((GRay origin: 2@1 direction: 4@1 )))
		  equals: {3@1}! !

!GRectangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 3/5/2015 14:59'!
testIntersectionPointsWith1
 	self assert:((Rectangle origin:  1 @ 3 corner: 3 @ 0) intersectionPointsWithLine: ((GSegment with: 0 @ 					3 with: 4 @ 1) asLine)) first
		  equals:  1 @ 2.5 .
	self assert:((Rectangle origin:  1 @ 3 corner: 3 @ 0) intersectionPointsWithLine: ((GSegment with: 0 @ 					3 with: 4 @ 1) asLine)) second
		  equals:  3 @ 1.5 ! !

!GRectangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 3/8/2015 20:22'!
testIntersectionPointsWith2
 	self assert:((Rectangle origin:  -60 @ -80 corner: 80 @ 60) intersectionPointsWithLine: ((GSegment with: 174.8683298050514@ -174.86832980505142 with: -14.868329805051376@14.868329805051385) asLine)) first
		  =~  (-60 @ 60) .
	self assert:((Rectangle origin:  -60 @ -80 corner: 80 @ 60) intersectionPointsWithLine: ((GSegment with: 174.8683298050514@ -174.86832980505142 with: -14.868329805051376@14.868329805051385) asLine)) second
		  =~  (80 @ -80) .! !

!GRectangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/23/2014 15:15'!
testSideWhichHas

self assert:((Rectangle origin:  1 @ 3 corner: 3 @ 0) sideWhichHas: 1 @ 2.5)
	equals: (GSegment with: 1 @ 3 with: 1 @ 0)  ! !

TestCase subclass: #GSegmentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry-Test'!

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 2/18/2015 09:28'!
testAlreadyExistIn
	|segm1 segm2 segm aSet |
	segm1 := GSegment with:5@2  with: 3@4.
	segm2 := GSegment with:1@1  with:4@8.
	segm := GSegment with: 0@0 with: 3@3.
	aSet := Set new.
	aSet add: segm1.
	aSet add: segm2.
	self assert: (segm alreadyExistIn:aSet )
		equals: false! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 2/18/2015 09:28'!
testAlreadyExistIn1
	|segm1 segm2 segm aSet |
	segm1 := GSegment with:1@2  with: 3@4.
	segm2 := GSegment with:1@1  with:2@2.
	segm := GSegment with: 0@0 with: 3@3.
	aSet := Set new.
	aSet add: segm1.
	aSet add: segm2.
	self assert: (segm alreadyExistIn:aSet )
"equels:true"! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/11/2014 18:02'!
testAsLine
|line|
	line := (GSegment with:  1 @ 3 with: 3 @ 0) asLine .
	self assert: line a equals: 3.
	self assert: line b equals: 2.
	self assert: line c equals: -9.! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/17/2014 15:25'!
testAsLine1
|line|
	line := (GSegment with:  -2 @ 4 with: 2 @ 4) asLine .
	self assert: line a equals: 0.
	self assert: line b equals: 1.
	self assert: line c equals: -4.! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/11/2014 18:05'!
testAsLine2
|line|
	line := (GSegment with:  1 @ 3 with: 1 @ 0) asLine .
	self assert: line a equals: 1.
	self assert: line b equals: 0.
	self assert: line c equals: -1.! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/17/2014 15:24'!
testBelowPoint
self assert:((GSegment with:  -2 @ 4 with: 2 @ 4) belowPoint: -2 @ 4 ) 
	equals: false.! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/17/2014 15:28'!
testBelowPoint1

self assert:((GSegment with:  -2 @ 4 with: 2 @ 4) belowPoint: 0 @ 5 ) 
	equals: true.
self assert:((GSegment with:  -2 @ 4 with: 2 @ 4) belowPoint: 0 @ -5 ) 
	equals: false.! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/17/2014 15:46'!
testBelowPoint2
self assert:((GSegment with:  -2 @ 4 with: -2 @ 0) belowPoint: 0 @ 2 ) 
	equals: true.
self assert:((GSegment with:  -2 @ 4 with: -2 @ 0) belowPoint: -4 @ 2 ) 
	equals: false.! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchyk 1/21/2015 13:40'!
testCutWith
	self
		assert: ((GSegment with: -10 @ 10 with: 20 @ 30) cutWith: (Rectangle origin: -15 @ 0 corner: 15 @ 15 )) v1
		equals: (-5/2)@15.
	self
		assert: ((GSegment with: -10 @ 10 with: 20 @ 30) cutWith: (Rectangle origin: -15 @ 0 corner: 15 @ 15 )) v2
		equals: -10 @ 10.	
	self
		assert: ((GSegment with: -30 @ 0 with: 20 @ 30) cutWith: (Rectangle origin: -15 @ 0 corner: 15 @ 15 )) v1 
		equals: (-15 @ 9) .	
	self
		assert: ((GSegment with: -30 @ 0 with: 20 @ 30) cutWith: (Rectangle origin: -15 @ 0 corner: 15 @ 15 )) v2 
		equals: (-5 @ 15).
	self
		assert: ((GSegment with: -30 @ 30 with: 20 @ 30) cutWith: (Rectangle origin: -15 @ 0 corner: 15 @ 15 ))
		equals: nil.	! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 2/18/2015 09:31'!
testEqual
	|segm1 segm2 |
	segm1 := GSegment with: 1@2 with: 3@4.
	segm2 := GSegment with: 0@0 with: 3@3.

	self assert: (segm1 asLine = (segm2 asLine))
	equals:false! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 2/18/2015 09:31'!
testEqual1
	|segm1 segm2 |
	segm1 := GSegment with:1@1  with: 3@3.
	segm2 := GSegment with: 0@0 with: 3@3.

	self assert: (segm1 asLine = (segm2 asLine))
	equals:true! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 2/19/2015 15:39'!
testEqual2
	|segm1 segm2 |
	segm1 := GSegment with: ( -24.494897427831784 @ -24.494897427831795 ) with: ( 24.494897427831784 @ 24.49489742783178 ).
	segm2 := GSegment with: ( 24.494897427831784 @ 24.49489742783178 ) with: ( -24.494897427831784 @ -24.494897427831795 ).

	self assert: (segm1 asLine = (segm2 asLine))
	equals:true! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 2/19/2015 15:40'!
testEqual3
	|segm1 segm2 |
	segm1 := GSegment with: ( -24.494897427831784 @ -24.494897427831795 ) with: ( 24.494897427831784 @ 24.49489742783178 ).
	segm2 := GSegment with: ( 24.494897427831784 @ 24.49489742783178 ) with: ( -24.494897427831784 @ -24.494897427831795 ).

	self assert: (segm1 = segm2)
	equals:true! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 2/25/2015 14:46'!
testExtendSegmVert
	| segm1 segm2 segm3 frame |
	segm1 := (GSegment with: -2 @ 4 with: 2 @ 4).
	segm2 := (GSegment with: -2 @ 2 with: -2 @ 4).
	segm3 := (GSegment with: -2 @ 2 with: 2 @ 4).
	frame := Rectangle origin: -5 @ 0 corner: 5 @ 5.
	self
		assert: ( segm1 extendSegmVert: 2 @ 4 to: frame )
		equals: ( GSegment with: -2 @ 4 with: 5 @ 4 ).
	self
		assert: ( segm1 extendSegmVert: -2 @ 4 to: frame )
		equals: ( GSegment with: -5 @ 4 with: 2 @ 4 ).	
	self
		assert: ( segm2 extendSegmVert: -2 @ 2 to: frame )
		equals: ( GSegment with: -2 @ 0 with: -2 @ 4 ).	
	self
		assert: ( segm2 extendSegmVert: -2 @ 4 to: frame ) 
		equals: ( GSegment with: -2 @ 2 with: -2 @ 5 ).
	self
		assert: ( segm3 extendSegmVert: -2 @ 2 to: frame )
		equals: ( GSegment with: -5 @ (1/2) with: 2 @ 4 ).
	self
		assert: ( segm3 extendSegmVert: 2 @ 4 to: frame )
		equals: ( GSegment with: -2 @ 2 with: 4 @ 5 ).	! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/17/2014 15:16'!
testHasPoint

	self assert:((GSegment with:  1 @ 3 with: 3 @ 0) hasPoint: 1 @ 3)
   		equals: true.
	self assert:((GSegment with:  1 @ 3 with: 3 @ 0) hasPoint: 3 @ 0)
   		equals: true.
	self assert:((GSegment with:  -1 @ 1 with: 1 @ -1) hasPoint: 0 @ 0)
   		equals: true.! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/23/2014 15:39'!
testIntersect
	self
		assert: ((GSegment with: -1 @ -1 with: 1 @ 1) = (GSegment with: 1 @ 1 with: -1 @ -1))
		equals: true.
	self
		assert: ((GSegment with: -1 @ -1 with: 1 @ 1) = (GSegment with: -1 @ 1 with: -1 @ 1))
		equals: false.	! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/17/2014 16:19'!
testIntersect1
	self
		assert: ((GSegment with: -1 @ -1 with: 1 @ 1) intersect:(GSegment with: -3 @ 3 with: -1 @ 1))
		equals: nil! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 2/20/2015 11:06'!
testIntersect2
	self
		assert: ((GSegment with: -1 @ -1 with: 1 @ 1) intersect:(GSegment with: -3 @ 3 with: 2 @ -2))
		equals: (0@0)! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/7/2014 11:31'!
testIntersectionPointWithVector
	self
		assert: ((GSegment with: 2 @ 0 with: 2 @ 3) intersectionPointWithRay: (GRay origin: 0 @ 0  direction:  3 @ 2))
		equals: 2 @ (4/3).
	self
		assert: ((GSegment with: 2 @ 0 with: 2 @ 3) intersectionPointWithRay: (GRay origin: 0 @ 0  direction:  1 @ 1))
		equals: 2 @ 2.	
	self
		assert: ((GSegment with: -2 @ 0 with: -2 @ 3) intersectionPointWithRay: (GRay origin: 0 @ 0  direction:  1 @ 1))
		equals: nil.
	self
		assert: ((GSegment with: 0 @ 0 with: 0 @ 3) intersectionPointWithRay: (GRay origin: 0 @ 0  direction:  1 @ 1))
		equals: 0 @ 0.! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 2/19/2015 10:04'!
testIsOnLineWith
	self assert:((GSegment with:  -2 @ 4 with: 2 @ 4) isOnLineWith:  (GSegment with:  -2 @ 4 with: 2 @ 4) ) 
		equals: true.
	self assert:((GSegment with:  -4 @ 4 with: 4 @ 4) isOnLineWith:  (GSegment with:  -2 @ 4 with: 2 @ 4) ) 
		equals: true.
	self assert:((GSegment with:  -2 @ 3 with: 2 @ 4) isOnLineWith:  (GSegment with:  -2 @ 4 with: 2 @ 4) ) 
		equals: false.
	self assert:((GSegment with:  -2 @ 4 with: 2 @ 4) isOnLineWith:  (GSegment with:  -2 @ 2 with: 2 @ 2) ) 
		equals: false.! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/15/2014 19:48'!
testLength
	self
		assert: (GSegment with: 0 @ 0 with: 3 @ 4) length
		equals: 5! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/22/2014 16:20'!
testLength1
	self
		assert: (GSegment with: -2 @ 1 with: 3 @ 4) length
		equals: 34 sqrt! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/21/2014 12:49'!
testMidPoint
	self
		assert: (GSegment with: -1 @ 2 with: 2 @ 1) midPoint 
		equals: 0.5 @ 1.5! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/22/2014 16:21'!
testMidPoint1
	self
		assert: (GSegment with: 2 @ 1 with: 2 @ 1) midPoint 
		equals: 2 @ 1! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/11/2014 16:58'!
testPerpendicularBisector
	self
		assert: (GSegment with: -1 @ 2 with: 0 @ 0) perpendicularBisector a
		equals: 1! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/11/2014 17:33'!
testPerpendicularBisector1
|line|
	line := (GSegment with: 1 @ 3 with: -1 @ 1) perpendicularBisector. 
		self assert: line a equals: -2.
		self assert: line b equals: -2.
		self assert: line c equals: 4.! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/11/2014 16:58'!
testPerpendicularBisector2
	self
		assert: (GSegment with: -1 @ 2 with: 0 @ 0) perpendicularBisector b
		equals: -2! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/11/2014 17:36'!
testPerpendicularBisector3
|line|
	line := (GSegment with: 3 @ 0 with: 1 @ 3)  perpendicularBisector. 
		self assert: line a equals: -2.
		self assert: line b equals: 3.
		self assert: line c equals: -1/2.! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 2/22/2015 13:42'!
testextendWithAnd
|frame|
frame := Rectangle origin: -5 @ 0 corner: 5 @ 5 .
self assert:((GSegment with:  -2 @ 4 with: 2 @ 4) extendWith: 3 @ 4 and: frame) 
	equals: (GSegment with: -5 @ 4 with: 3 @ 4).! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 2/22/2015 13:43'!
testextendWithAnd1
|frame|
frame := Rectangle origin: -5 @ 0 corner: 5 @ 5 .
self assert:((GSegment with:  -2 @ 4 with: 2 @ 4) extendWith: 3 @ 4 and: frame) 
	equals: (GSegment with: 3 @ 4 with: -5 @ 4).! !

TestCase subclass: #GTriangleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry-Test'!

!GTriangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/15/2014 19:51'!
testArea
	self
		assert:
			((GTriangle with: 0 @ 0 with: 2 @ 0 with: 0 @ 2) area closeTo: 2)! !

!GTriangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/22/2014 16:21'!
testCircumscribedCircle
	| circle |
	circle := (GTriangle with: -1 @ 2 with: 0 @ 0 with: 2 @ 1) circumscribedCircle.
	self assert: circle center equals: 0.5 @ 1.5.
	self assert: (circle radius closeTo: 10 sqrt / 2)
	

! !

!GTriangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/11/2014 19:06'!
testCircumscribedCircle1
	| circle |
	circle := (GTriangle with: -1 @ 1 with: 3 @ 0 with: 1 @ 3) circumscribedCircle.
	self assert: circle center equals: (11/10) @ (9/10).
	self assert: (circle radius closeTo: (1+(21*21)) sqrt / 10)
	

! !

!GTriangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/11/2014 21:55'!
testCircumscribedCircle2
	| circle |
	circle := (GTriangle with: -1 @ 1 with: 2 @ 3  with: 5 @ -3) circumscribedCircle.
	self assert: circle center equals: (9 / 4) @ (-5 / 8).
	self assert: (circle radius closeTo: (5 sqrt)* 13 / 8 )
! !

!GTriangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/12/2014 20:30'!
testCircumscribedCircle3
	| circle |
	circle := (GTriangle with: 2 @ 3 with: 7 @ 4 with: 5 @ 7) circumscribedCircle.
	self assert: circle center equals: (147/34) @ (149/34).

	

! !

!GTriangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/26/2014 21:45'!
testIsDegenerate
	self
		assert: (GTriangle with: 0 @ 0 with: 2 @ 0 with: 3 @ 0) isDegenerate.
	self
		assert: (GTriangle with: 0 @ 0 with: 2 @ 0 with: 0 @ 3) isDegenerate not.
	self
		assert: (GTriangle with: 1 @ 0 with: 1 @ 2 with: 1 @ -1) isDegenerate.	! !

!GTriangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchyk 1/21/2015 15:18'!
testIsDegenerate2
self
	assert: (GTriangle with: 1@1 with: 3@3 with: 2@2 )isDegenerate.

self
	assert: (GTriangle with:  1@1 with: 2@2 with: 3@3 )isDegenerate.

self
	assert: (GTriangle with:  1@1 with: 2@2 with: 2@1 )isDegenerate not.
! !

!GTriangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchyk 1/21/2015 15:22'!
testIsDegenerate3
self
	assert: (GTriangle with: (1.9357176033002985e-6@212.13203242024665) with: (1.1175870793405243e-6@122.47448602157178) with: (1.5805068047363063e-6@173.2050791763809))isDegenerate.

self
	assert: (GTriangle with: (1.9357176033002985e-6@212.13203242024665) with: (-2.7375180875116245e-6@299.9999972624819) with: (1.5805068047363063e-6@173.2050791763809))isDegenerate not.

self
	assert: (GTriangle with: (1.9357176033002985e-6@212.13203242024665) with: (-2.7375180875116245e-6@299.9999972624819) with: (1.1175870793405243e-6@122.47448602157178))isDegenerate not.
! !

!GTriangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 2/27/2015 09:23'!
testIsDegenerate4
self
	assert: (GTriangle with: (-10@ -30) with:(-30@ -10) with:(-10@ -30))isDegenerate.

! !

!GTriangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/15/2014 19:41'!
testPerimeter
	self
		assert: (GTriangle with: 0 @ 0 with: 2 @ 0 with: 0 @ 2) perimeter
		equals: 4 + 8 sqrt! !

!GTriangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/15/2014 19:41'!
testSemiperimeter
	self
		assert: (GTriangle with: 0 @ 0 with: 2 @ 0 with: 0 @ 2) semiperimeter
		equals: 2 + 2 sqrt! !

!Rectangle methodsFor: '*Geometry' stamp: 'NataliaTymchuk 6/19/2014 17:06'!
edges
	^ { 
		GSegment with: (self origin ) with: (self origin x @ self corner y). 
		GSegment with: (self origin x @ self corner y) with: (self corner).
		GSegment with: (self corner ) with: (self corner x @ self origin y).
 		GSegment with: (self corner x @ self origin y) with: (self origin).
}
! !

!Rectangle methodsFor: '*Geometry' stamp: 'NataliaTymchuk 6/30/2014 22:06'!
hasOnBoundary: point
| a |
	a := self edges select: [:edge | a := edge hasPoint: point].
	^a isNotEmpty! !

!Rectangle methodsFor: '*Geometry' stamp: 'NataliaTymchuk 6/23/2014 16:59'!
hasOnOneSide: point1 and: point2 
 ^	
	((point1 x = point2 x and:[point1 x = self origin x or:[point1 x = self corner x]] )
or:[point1 y = point2 y and:[point1 y = self origin y or:[point1 y = self corner y]] ])! !

!Rectangle methodsFor: '*Geometry' stamp: 'NataliaTymchuk 6/27/2014 21:40'!
hasPoint: point 
"inside the frame and on the boundary"
 ^	((self origin x <= point x and: [point x <= self corner x])
	and:[ (self origin y <= point y and: [point y <= self corner y]) 
	or:[self origin y >= point y and: [point y >= self corner y]]])
	or:
	[(self origin x >= point x and: [point x >= self corner x ])
	and:[ (self origin y <= point y and: [point y <= self corner y]) 
	or:[self origin y >= point y and: [point y >= self corner y]]]
	]! !

!Rectangle methodsFor: '*Geometry' stamp: 'NataliaTymchuk 2/17/2015 00:25'!
intersectionPointWithRay: ray

^ self edges collect:[ :edge | edge intersectionPointWithRay: ray]  
				thenReject: #isNil.
	! !

!Rectangle methodsFor: '*Geometry' stamp: 'NataliaTymchuk 3/5/2015 15:12'!
intersectionPointsWithLine: line
	|points ps|
	ps := OrderedCollection new.
	points := OrderedCollection new.
 	self edges do:[ :edge | 
		|p|
		p := edge intersectionPointWithLine: line.
		p isNotNil 
			ifTrue:[ (ps noneSatisfy: [:pi| pi =~p]) ifTrue:[
			ps add: p ]]]. 
	^ ps

"^ self edges collect:[ :edge | edge intersectionPointWithLine: line]  
				thenReject: #isNil."
	! !

!Rectangle methodsFor: '*Geometry' stamp: 'NataliaTymchuk 6/27/2014 11:53'!
intersectionPointsWithSegment: segm

^ self edges collect:[ :edge | edge intersectionPointWithSegment: segm]  
				thenReject: #isNil.
	! !

!Rectangle methodsFor: '*Geometry' stamp: 'NataliaTymchuk 6/19/2014 20:23'!
sideWhichHas: point
	
	^ self edges detect: [ :edge | edge hasPoint: point ]
! !

!Rectangle methodsFor: '*Geometry' stamp: 'NataliaTymchuk 7/6/2014 23:13'!
vertices

	^ { origin . 
		origin x @ corner y . 
		corner. 
		corner x @ origin y }! !

Object subclass: #GCircle
	instanceVariableNames: 'center radius'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry'!

!GCircle commentStamp: 'NataliaTymchuk 6/27/2014 21:12' prior: 0!
I am a circle. I have a center in (cx, cy) and radius. My equation is: 
(x-cx)^2  + (y-cy)^2 = radius^2 or 
a * (x^2) + a * (y^2) + d * x + e * y + f = 0 
!

!GCircle class methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/20/2014 10:49'!
center: aPoint1 radius: aNumber
	^ self new initializeWithCenter: aPoint1 radius: aNumber! !

!GCircle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 3/2/2015 15:24'!
= circ
	^( self radius =~ circ radius and:[ self center =~ circ center ])


! !

!GCircle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 3/2/2015 10:12'!
boundaryContains:aPoint
^(self radius =~ (self center dist: aPoint)) 
! !

!GCircle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/20/2014 18:44'!
boundaryContainsThis: points

 ^(points select:[ :point| self boundaryContains: point]) isNotEmpty 
! !

!GCircle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/20/2014 18:40'!
boundaryContainsWhichOf: points
 ^ points select:[ :point| self boundaryContains: point]
! !

!GCircle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/20/2014 10:50'!
center

^center ! !

!GCircle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/9/2014 18:20'!
contains:aPoint
^ (self radius > (self center dist: aPoint)) ! !

!GCircle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/20/2014 10:48'!
initializeWithCenter: aPoint1 radius: aNumber
	super initialize.
	center := aPoint1.
	radius := aNumber.! !

!GCircle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/20/2014 18:16'!
polygonOn: points
|polygonSegm firstP notUsedPoints currentP|
	currentP := points anyOne.
	firstP := currentP.
	notUsedPoints := points asOrderedCollection remove: currentP; yourself.
	polygonSegm := OrderedCollection new.
	
	[ notUsedPoints isNotEmpty ] whileTrue: [
		| nextP |
		nextP := notUsedPoints detectMin: [ :point | point dist: currentP ].
		polygonSegm add:( GSegment with: currentP with: nextP).
		currentP := nextP.
		notUsedPoints remove: currentP ].
	polygonSegm add:( GSegment with: currentP with: firstP).
	^ polygonSegm! !

!GCircle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/20/2014 10:51'!
radius

^radius ! !

!GCircle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 2/17/2015 22:22'!
upperPoint
	^ center x @ ( center y + radius )! !

Object subclass: #GLine
	instanceVariableNames: 'a b c'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry'!

!GLine commentStamp: 'NataliaTymchuk 5/21/2014 11:34' prior: 0!
A GLine has 3 instance variables, which are koeficients  of line:
ax+by+c=0

!

!GLine class methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/21/2014 11:33'!
a: aNumber1 b: aNumber2 c: aNumber3
	^ self new initializeWithA: aNumber1 b: aNumber2 c: aNumber3! !

!GLine class methodsFor: 'as yet unclassified' stamp: 'NataliaTymchyk 1/21/2015 13:35'!
through: aPoint1 and: aPoint2
|ai bi ci|
(aPoint1 y) = (aPoint2 y) ifTrue:
[ ^ GLine
		a: 0 b: 1 c: ((aPoint1 y) negated)].
(aPoint1 x) = (aPoint2 x) ifTrue:[ 
	^ GLine
		a: 1 b: 0 c: ((aPoint1 x) negated)].	
ai := (aPoint1 y) - (aPoint2 y). 
bi := (aPoint2 x) - (aPoint1 x).
ci := ((aPoint1 x) - (aPoint2 x)) * (aPoint1 y) + ( ((aPoint2 y) - (aPoint1 y)) * (aPoint1 x) ).
^ self	 a:ai b: bi c: ci! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 2/19/2015 16:26'!
= line 
^( self a asFloat =~ line a asFloat and: [ self b asFloat =~ line b asFloat and: [ self c asFloat =~ line c asFloat ] ] )  
or:
[ ( line a ~=~ 0 and: [ line b ~=~ 0 and: [ line c ~=~ 0 ] ] ) 
	ifTrue: [ ( self a / line a ) asFloat =~ ( self b / line b ) asFloat and: [ ( self b / line b ) asFloat =~ ( self c / line c ) asFloat] ]
	ifFalse:[ ( self a ~=~ 0 and: [self b ~=~ 0 and: [ self c ~=~ 0 ]]) 
		ifTrue: [ ( line a / self a ) asFloat =~ ( line b / self b) asFloat and: [ ( line b / self b ) asFloat =~ ( line c / self c ) asFloat ] ]
		ifFalse:[ ( line a ~=~ 0 and: [ line c ~=~ 0 ] )
			ifTrue:[ ( self a / line a ) asFloat =~ ( self c / line c ) asFloat]
			ifFalse:[ ( line b ~=~ 0 and:[ line c ~=~ 0] )
				ifTrue:[ ( self b / line b ) asFloat =~ ( self c / line c ) asFloat ] 
				ifFalse:[ ( line a ~=~ 0 and:[ line b ~=~ 0] )
					ifTrue:[ ( self a / line a ) asFloat =~ ( self b / line b ) asFloat ] 
					ifFalse:[ ( line a =~ 0 and: [ line c =~ 0 ] ) or: [ ( line b =~ 0 and: [ line c =~ 0 ] ) ]
					]
				] 
			]]]
	]
! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/21/2014 11:32'!
a
	^a
! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/6/2014 22:55'!
asLine
	^ self ! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/20/2014 10:46'!
b
	^b
! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/21/2014 11:32'!
c
	^c
! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/6/2014 22:56'!
cutWith: frame
| coll |
coll := OrderedCollection new.
frame edges
	collect: [ :edge | edge intersectionPointWithLine: self ]
	thenDo: [ :p |
		(p notNil and: [ coll noneSatisfy: [ :p2 | p2 =~ p ] ])
			ifTrue: [ coll add: p ] ] .
coll isEmpty
	ifTrue:  [ ^ nil ]
	ifFalse: [ ^ GSegment with: coll first with: coll second ]
					
! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchyk 1/21/2015 13:16'!
hasPoint: aPoint

	^ a * aPoint x + (b * aPoint y) + c =~ 0! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/11/2014 15:05'!
hash
^( a hash  + b hash + c hash ) hashMultiply
! !

!GLine methodsFor: 'initialization' stamp: 'NataliaTymchuk 5/21/2014 11:33'!
initializeWithA: aNumber1 b: aNumber2 c: aNumber3
	super initialize.
	a := aNumber1.
	b := aNumber2.
	c := aNumber3.! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/12/2014 20:18'!
intersect: aGLine 
	| xi yi |

	(self parallelTo: aGLine) ifTrue: [ ^ nil ].
					
	yi := (self c * (aGLine a) - (self a * (aGLine c)))
			/ 
			(self a * (aGLine b) - (self b * (aGLine a))).

	xi := self a isZero
		ifTrue: [
			 ( aGLine b * yi + (aGLine c)) negated / (aGLine a)]
		ifFalse: [
			 ( self b * yi + self c) negated / self a].
	
	^xi@yi.



! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/12/2014 20:18'!
parallelTo: aLine

	^ (self a isZero & aLine a isZero) or:
	[ (self b isZero & aLine b isZero) or:
	[ (aLine a isZero | aLine b isZero) not and:
	[ (self a / aLine a) = (self b / aLine b) ] ] ]! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/6/2014 21:52'!
pointsWithDist: aNumber to: aPoint
	| deltaX delta |
	
	(self hasPoint: aPoint) ifFalse: [
		Error signal: 'This line does not contain ', aPoint asString ].

	b = 0 ifTrue: [
		^ { aPoint + (0 @ aNumber) . aPoint - (0 @ aNumber) } ].
	
	deltaX := aNumber / ((a / b) squared + 1) sqrt.		
	delta := deltaX @ (deltaX * a / b) negated.

	^ { aPoint + delta . aPoint - delta }
	! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/11/2014 15:39'!
printOn: aStream
	a printOn: aStream.
	aStream nextPutAll: 'x '.
	b sign >= 0 ifTrue: [ 
		aStream nextPut: $+ ].
	b printOn: aStream.
	aStream nextPutAll: 'y '.
	c sign >= 0 ifTrue: [ 
		aStream nextPut: $+ ].
	c printOn: aStream.
	aStream nextPutAll: ' = 0'.
	! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchyk 1/21/2015 13:46'!
through: aPoint1 and: aPoint2 hasPoint: aPoint

	^(GTriangle with: aPoint1 with: aPoint2 with: aPoint) isDegenerate . ! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/27/2014 22:27'!
xFor: anY

	^ ((anY * b + c) / a) negated! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/27/2014 22:27'!
yFor: anX

	^ ((anX * a + c) / b) negated! !

Object subclass: #GPolygon
	instanceVariableNames: 'vertices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry'!

!GPolygon commentStamp: 'NataliaTymchuk 6/27/2014 21:14' prior: 0!
I'm polygon builded on my vertices.

!

!GPolygon class methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 2/17/2015 16:29'!
convexHullOn: aCollection
	| lastPoint nextPoint convexHull |
"self halt."	
	convexHull := OrderedCollection new.	
	nextPoint := aCollection detectMin: #x.
	 [
		lastPoint := nextPoint.
		convexHull add: lastPoint.
		nextPoint := aCollection detect: [ :point | point ~= lastPoint ].
		(aCollection copyWithout: nextPoint) do: [ :point |
			| turn |		
			turn :=
				(nextPoint x - lastPoint x) * (point y - lastPoint y) -
				((point x - lastPoint x) * (nextPoint y - lastPoint y)).
			(turn < 0 or:
				[ turn = 0 and:
				[ (lastPoint dist: point) > (lastPoint dist: nextPoint) ] ]) ifTrue:
					[ nextPoint := point ] ] ] doWhileTrue: [
				convexHull first ~= nextPoint ].
		
	^ self newVertices: convexHull
				! !

!GPolygon class methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/27/2014 20:03'!
newVertices: aCollection
	
	^ self new
		initializeVertices: aCollection;
		yourself.! !

!GPolygon methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/27/2014 20:03'!
initializeVertices: aCollection
	self initialize.
	
	vertices := aCollection ! !

!GPolygon methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/27/2014 20:03'!
vertices
	
	^ vertices! !

Object subclass: #GRay
	instanceVariableNames: 'origin direction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry'!

!GRay commentStamp: 'NataliaTymchuk 6/27/2014 21:12' prior: 0!
I am a vector builded on line ax+by+c=0 and have my start in point v1.

!

!GRay class methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/27/2014 23:02'!
origin: aPoint1 direction: aPoint2
	^ self new initializeWithOrigin: aPoint1 direction: aPoint2! !

!GRay methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 3/3/2015 12:39'!
= aRay

^ self origin =~ aRay origin and: [
 (self origin bearingToPoint: self direction) =~
 (aRay origin bearingToPoint: aRay direction) ]
! !

!GRay methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/2/2014 11:21'!
asLine
|ai bi ci|
(self origin  y) = (self direction  y) ifTrue:
[ ^ GLine
		a: 0 b: 1 c: ((self origin y) negated)].
(self origin x) = (self direction x) ifTrue:[ 
	^ GLine
		a: 1 b: 0 c: ((self origin x) negated)].	
ai := (self origin y) - (self direction y). 
bi := (self direction x) - (self origin x).
ci := ((self origin x) - (self direction x)) * (self origin y) + ( ((self direction y) - (self origin y)) * (self origin x) ).
^ GLine
		a:ai b: bi c: ci
! !

!GRay methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/7/2014 11:31'!
cutWith: frame
| coll |
coll := OrderedCollection new.
frame edges
	collect: [ :edge | edge intersectionPointWithRay: self ]
	thenDo: [ :p |
		(p notNil and: [ coll noneSatisfy: [ :p2 | p2 =~ p ] ])
			ifTrue: [ coll add: p ] ] .
coll isEmpty ifTrue:[^ nil]
				 ifFalse:[coll size = 2 
					ifTrue:  [ ^GSegment with: coll first with: coll second ]
					ifFalse: [ ^GSegment with: coll first with: self origin ] ]! !

!GRay methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/2/2014 11:21'!
direction
	^direction 
! !

!GRay methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/7/2014 11:29'!
flipped

	^ GRay origin: self origin direction: (origin + (origin - direction))
! !

!GRay methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/6/2014 23:47'!
hasPoint: aPoint
^ (( origin - direction ) signFuz = ( origin - aPoint ) signFuz  or:
					[ origin = aPoint ])
 
! !

!GRay methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/7/2014 12:35'!
hash
	^ ( self origin hash hashMultiply +
		(self origin bearingToPoint: self direction) hash ) hashMultiply
! !

!GRay methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/2/2014 13:31'!
initializeWithOrigin: aPoint1 direction: aPoint2
	super initialize.
	origin  := aPoint1.
	direction  := aPoint2 
! !

!GRay methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/2/2014 20:47'!
length
	^ direction dist: origin
! !

!GRay methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/2/2014 11:20'!
origin 
	^origin
! !

Object subclass: #GSegment
	instanceVariableNames: 'v1 v2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry'!

!GSegment commentStamp: 'NataliaTymchuk 5/15/2014 19:46' prior: 0!
I am a segment between two vertices!

!GSegment class methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/15/2014 19:46'!
with: aPoint1 with: aPoint2
	^ self new initializeWith: aPoint1 with: aPoint2! !

!GSegment methodsFor: 'initialization' stamp: 'NataliaTymchuk 2/19/2015 15:25'!
= segment
^
((self v1 =~ segment v1) and: [self v2 =~ segment v2]) 
or: 
[(self v1 =~ segment v2) and: [self v2 =~ segment v1]]! !

!GSegment methodsFor: 'properties' stamp: 'NataliaTymchuk 2/18/2015 15:36'!
alreadyExistIn: aSet 
 	aSet do:[:eachS | (eachS asLine = (self asLine) )ifTrue:[ ^ true ]].
	^ false! !

!GSegment methodsFor: 'properties' stamp: 'NataliaTymchuk 7/11/2014 17:33'!
asLine
	^ GLine through: v1 and: v2! !

!GSegment methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/17/2014 15:25'!
belowPoint:p
^( (self v2 x - self v1 x)*(p y - self v1 y)-((self v2 y - self v1 y)*(p x - self v1 x))> 0 )
	
! !

!GSegment methodsFor: 'properties' stamp: 'NataliaTymchuk 6/15/2014 17:56'!
boundBy: aPoint
	^ self v1 = aPoint or: [ self v2 = aPoint ]! !

!GSegment methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/6/2014 22:56'!
cutWith: frame
| coll |
coll := OrderedCollection new.
frame edges
	collect: [ :edge | edge intersectionPointWithSegment: self ]
	thenDo: [ :p |
		(p notNil and: [ coll noneSatisfy: [ :p2 | p2 =~ p ] ])
			ifTrue: [ coll add: p ] ].
coll ifEmpty: [ "self halt".
	(frame hasPoint: self v1)
		ifTrue:  [ ^ self ]
		ifFalse: [ ^ nil ] ].

coll size = 2 
	ifTrue: [ ^ GSegment with: coll first with: coll second ].

(frame hasPoint: self v1) 
	ifTrue:  [ ^ GSegment with: coll first with: self v1 ] 
	ifFalse: [ ^ GSegment with: coll first with: self v2 ]
							
	
! !

!GSegment methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 2/25/2015 14:23'!
extendSegmVert: v to: frame
	|points ver p|
	points := frame intersectionPointsWithLine: self asLine.
	ver := self vertices detect:[:vi | (vi = v) not].
	( ver x = v x ) 
		ifTrue:[ ( ver y > v y )
			ifTrue: [ p := points detect:[ :pi | pi y < v y] ]
			ifFalse:[ p := points detect:[ :pi | pi y > v y] ]]
		ifFalse:	[ ( ver x > v x )
			ifTrue: [ p := points detect:[ :pi | pi x < v x] ]
			ifFalse:[ p := points detect:[ :pi | pi x > v x] ]
			 ].
^ GSegment with: ver with: p
							
	
! !

!GSegment methodsFor: 'properties' stamp: 'NataliaTymchuk 2/22/2015 13:43'!
extendWith: point and: frame
	|points v|
	(self asLine hasPoint: point) 
		ifTrue:[ 
			(( self v1 dist: point ) < ( self v2 dist: point ))
				ifTrue:[ v1 := point]
				ifFalse:[ v2 := point].
			v := self vertices detect:[:p | (p = point) not ].
			points := frame intersectionPointsWithLine: (self asLine).
			points size = 2 
				ifTrue:[  ( ( GSegment with: point with: points first ) hasPoint: v )  
					ifTrue:[ ^ GSegment with: point with: points first ]
					ifFalse:[ ^ GSegment with: point with: points second] ]]
		! !

!GSegment methodsFor: 'properties' stamp: 'NataliaTymchuk 6/23/2014 18:46'!
hasPoint:aPoint

  ^( (self v1 x <=~ aPoint x and: [aPoint x <=~ self v2 x])  or:
		[self v2 x <=~ aPoint x and: [aPoint x <=~ self v1 x]]  ) and: 
   [ (self v1 y <=~ aPoint y and: [aPoint y <=~ self v2 y])  or:
		[self v2 y <=~ aPoint y and: [aPoint y <=~ self v1 y]]   ]  .
   
! !

!GSegment methodsFor: 'initialization' stamp: 'NataliaTymchuk 6/12/2014 16:04'!
hash
^( v1 hash  + v2 hash ) hashMultiply! !

!GSegment methodsFor: 'initialization' stamp: 'NataliaTymchuk 5/15/2014 19:46'!
initializeWith: aPoint1 with: aPoint2
	super initialize.
	v1 := aPoint1.
	v2 := aPoint2! !

!GSegment methodsFor: 'properties' stamp: 'NataliaTymchuk 2/20/2015 11:03'!
intersect: aSegment

(self v1 to: self v2 intersects: aSegment v1 to: aSegment v2) 
	ifTrue:	[^self asLine intersect: (aSegment asLine)]
	ifFalse: [^nil]
! !

!GSegment methodsFor: 'properties' stamp: 'NataliaTymchuk 6/27/2014 11:48'!
intersectionPointWithLine: aLine

	^ (self asLine intersect: aLine) ifNotNilDo: [ :point | 
		(self hasPoint: point)
			ifTrue:  [ point ]
			ifFalse: [ nil ] ]
! !

!GSegment methodsFor: 'properties' stamp: 'NataliaTymchuk 7/7/2014 11:32'!
intersectionPointWithRay: ray

	^ (self asLine intersect: ray asLine) ifNotNilDo: [ :point | 
		((self hasPoint: point) and:
				[ray hasPoint: point])
			ifTrue:  [ point ]
			ifFalse: [ nil ] ]
! !

!GSegment methodsFor: 'properties' stamp: 'NataliaTymchuk 7/2/2014 20:57'!
intersectionPointWithSegment: segm

	^ (self asLine intersect: segm asLine) ifNotNilDo: [ :point | 
		((self hasPoint: point) and:[segm hasPoint: point])
			ifTrue:  [ point ]
			ifFalse: [ nil ] ]
! !

!GSegment methodsFor: 'properties' stamp: 'NataliaTymchuk 2/19/2015 10:01'!
isOnLineWith: segm
	self = segm 
		ifTrue:[^ true]
		ifFalse:[^ self asLine = (segm asLine)]! !

!GSegment methodsFor: 'properties' stamp: 'NataliaTymchuk 5/15/2014 19:49'!
length
	^ v1 dist: v2! !

!GSegment methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/6/2014 23:47'!
locationOf: aPoint
    
    ^ ((self v2 x - self v1 x) * (aPoint y - self v1 y) - 
      ((self v2 y - self v1 y) * (aPoint x - self v1 x))) signFuz! !

!GSegment methodsFor: 'properties' stamp: 'NataliaTymchuk 6/28/2014 17:31'!
midPoint
 ^ (v1 + v2) / 2.! !

!GSegment methodsFor: 'properties' stamp: 'NataliaTymchuk 6/11/2014 16:32'!
perpendicularBisector

^GLine
a:  (v2 x - v1 x)
b:  (v2 y - v1 y)
c: ((v1 x * v1 x) - (v2 x * v2 x) + (v1 y * v1 y) - (v2 y * v2 y))/2
! !

!GSegment methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/15/2014 15:25'!
printOn: aStream
	v1 printOn: aStream.
	aStream nextPutAll: '>-<'.
	v2 printOn: aStream! !

!GSegment methodsFor: 'accessing' stamp: 'NataliaTymchuk 5/20/2014 11:05'!
v1
^v1

! !

!GSegment methodsFor: 'accessing' stamp: 'NataliaTymchuk 5/20/2014 11:06'!
v2
^v2

! !

!GSegment methodsFor: 'initialization' stamp: 'NataliaTymchuk 6/15/2014 13:03'!
vertices
	^ { v1 . v2 }! !

Object subclass: #GTriangle
	instanceVariableNames: 'v1 v2 v3 area edgesByOpositeVertex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry'!

!GTriangle commentStamp: 'NataliaTymchuk 5/15/2014 19:07' prior: 0!
I am a triangle!

!GTriangle class methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/15/2014 19:10'!
with: aPoint1 with: aPoint2 with: aPoint3
	^ self new initializeWith: aPoint1 with: aPoint2 with: aPoint3! !

!GTriangle methodsFor: 'properties' stamp: 'NataliaTymchuk 5/21/2014 12:37'!
area
	| semiperimeter|
	semiperimeter := self semiperimeter.

	^ (self edges 
		inject: semiperimeter
		into: [ :subProduct :edge |
			semiperimeter - edge length * subProduct ]) sqrt! !

!GTriangle methodsFor: 'figures' stamp: 'NataliaTymchuk 1/23/2015 15:27'!
circumscribedCircle
	| center radius |
	center := self edges first perpendicularBisector intersect: self edges last perpendicularBisector.
	center isNil ifTrue: [ ^nil ] ifFalse: [ radius := (v1 dist: v2) * (v2 dist: v3) * (v3 dist: v1) / (4 * self area).
		^GCircle center: center radius: radius ] 
	
	"^ GCircle
		center:
			(self edges first perpendicularBisector intersect:
			 self edges last perpendicularBisector)
		radius: (v1 dist: v2) * (v2 dist: v3) * (v3 dist: v1) / (4 * self area)"! !

!GTriangle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/27/2014 22:13'!
edges
	^ self edgesByOpositeVertex values! !

!GTriangle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/27/2014 23:34'!
edgesByOpositeVertex

	^ edgesByOpositeVertex ifNil: [
		edgesByOpositeVertex := {
			v1 -> (GSegment with: v2 with: v3) .
			v2 -> (GSegment with: v3 with: v1) .
	   		v3 -> (GSegment with: v1 with: v2)  } asDictionary ]! !

!GTriangle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 2/20/2015 11:09'!
hasTwoIntersectionWithSegm: segm
	|i|
	i := 0.
	self edges do:[:e | (e intersect: segm) isNotNil ifTrue:[ i := i + 1 ] ].
	^ (i = 2 or:[ i = 3])! !

!GTriangle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/15/2014 19:09'!
initializeWith: aPoint1 with: aPoint2 with: aPoint3
	super initialize.
	v1 := aPoint1.
	v2 := aPoint2.
	v3 := aPoint3 ! !

!GTriangle methodsFor: 'figures' stamp: 'NataliaTymchuk 2/27/2015 09:27'!
isDegenerate
(v1 = v2 or:[ v1 = v3 or:[ v2 = v3 ]])
	ifTrue:[^ true]
	ifFalse:[
	^  (self edges first length + self edges second length ="closeTo:" (self edges third length)) or: [ 
		(self edges second length + self edges third length ="closeTo:" (self edges first length)) or: [ 
		 self edges third length + self edges first length ="closeTo:" (self edges second length) ] ]]! !

!GTriangle methodsFor: 'properties' stamp: 'NataliaTymchuk 5/15/2014 19:49'!
perimeter
	^ self edges
		inject: 0
		into: [ :subSum :edge |
			subSum + edge length ]! !

!GTriangle methodsFor: 'properties' stamp: 'NataliaTymchuk 5/15/2014 19:50'!
semiperimeter
	^ self perimeter / 2! !

!GTriangle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/5/2014 21:16'!
vertices

	^ { v1 . v2 . v3 }! !

!Object methodsFor: '*Geometry' stamp: 'NataliaTymchuk 6/23/2014 18:48'!
<=~ other
	^ self < other or: [ self =~ other ]! !

!Object methodsFor: '*Geometry' stamp: 'NataliaTymchuk 6/23/2014 18:48'!
<~ other
	^ (self >=~ other) not! !

!Object methodsFor: '*Geometry' stamp: 'NataliaTymchuk 6/23/2014 18:48'!
>=~ other
	^ other <=~ self! !

!Object methodsFor: '*Geometry' stamp: 'NataliaTymchuk 6/23/2014 18:48'!
>~ other
	^ other <~ self! !
